

  MEMBER

OMIT('***')
 * Created by Clarion 7.0
 * User: PW
 * Date: 1/8/2011
 * Time: 11:17 AM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 ***

  MAP
   CheckQuery(STRING),BYTE
   DecodeQuery(STRING),STRING
   BuildAction(STRING),PROC
  END


LOC:QueryBuilder     STRING(10000)                         !
LOC:QueryField       STRING(250)                           !
LOC:QueryAction      STRING(250)                           !
LOC:Alpha            STRING(1000)                          !

QCheckView          VIEW(A_GenericValues)
                      PROJECT(GV:String1)
                    END

QuerySetup          ROUTINE
  DO GetQueryFields
  DO GetQueryActions

  
GetQueryFields      ROUTINE
  DATA
FieldQ  QUEUE
FieldName STRING(250)
        END
FieldCount  LONG
Counter LONG
FromString  STRING(5000)
TempString  STRING(250)
PrefixLen   LONG
  CODE

    FieldCount = QD_Hold{PROP:Fields}
    PrefixLen = LEN('QDH:')
    LOOP FieldCount TIMES
      Counter += 1
      TempString = WHO(QDH:Record,Counter)
      FromString = CLIP(FromString) & 'QD_Hold.[' & TempString[PrefixLen + 1 : LEN(CLIP(TempString))] & ']|'
    END

    CLEAR(Counter)
    FieldCount = ID_Lot{PROP:Fields}
    PrefixLen = LEN('ID_L:')
    LOOP FieldCount TIMES
      Counter += 1
      TempString = WHO(ID_L:Record,Counter)
      FromString = CLIP(FromString) & 'ID_Lot.[' & TempString[PrefixLen + 1 : LEN(CLIP(TempString))] & ']|'
    END

    IF CLIP(FromString) THEN FromString = FromString[1 : LEN(CLIP(FromString)) - 1].
    ?LOC:QueryField{PROP:From} = UPPER(CLIP(FromString))


GetQueryActions     ROUTINE
  DATA
FromString  STRING(5000)
  CODE
    FromString = '=|<>|>|<|>=|<=|BETWEEN|IN|NOT|AND|OR|LIKE|UPPER|LOWER|EXISTS|CONTAINS|MIN|MAX|AVG|SUM|COUNT|ALL|,|.|(|)'
    ?LOC:QueryAction{PROP:From} = CLIP(FromString)

BuildField          ROUTINE
  IF CLIP(LOC:QueryBuilder)
    LOC:QueryBuilder = CLIP(LOC:QueryBuilder) & ' ' & (LOC:QueryField)
  ELSE
    LOC:QueryBuilder = CLIP(LOC:QueryField)
  END

  DISPLAY(?LOC:QueryBuilder)

  IF CheckQuery(LOC:QueryBuilder) THEN DO GoGreen ELSE DO GoRed.

! [Priority 4000]
BuildText           ROUTINE
  IF CLIP(LOC:QueryBuilder)
    LOC:QueryBuilder = CLIP(LOC:QueryBuilder) & ' ' & CLIP(LOC:Alpha)
  ELSE
    LOC:QueryBuilder = CLIP(LOC:Alpha)
  END

  CLEAR(LOC:Alpha)
  DISPLAY(?LOC:QueryBuilder)
  DISPLAY(?LOC:Alpha)

  IF CheckQuery(LOC:QueryBuilder) THEN DO GoGreen ELSE DO GoRed.

! [Priority 4000]
EnterAll            ROUTINE
  DO BuildField
  BuildAction(LOC:QueryAction)
  DO BuildText


! [Priority 4000]
ClearAll            ROUTINE
  CLEAR(LOC:QueryBuilder)
  DISPLAY(?LOC:QueryBuilder)

  IF CheckQuery(LOC:QueryBuilder) THEN DO GoGreen ELSE DO GoRed.

! [Priority 4000]
ExecQuery           ROUTINE
  IF ~CheckQuery(LOC:QueryBuilder)
    MESSAGE('Your query statement contains errors.  Please correct these errors first.','Query Not Executed..')
    EXIT
  END

  BRW4::View:Browse{PROP:SQLFilter} = CLIP(DecodeQuery(LOC:QueryBuilder))
  BRW4.ResetFromBuffer
  BRW4.PostNewSelection

! [Priority 4000]
GoGreen             ROUTINE
  ?StatusImage{PROP:Text} = '~KPServSuccess.ico'
  ?PrintButton{PROP:Disable} = FALSE

! [Priority 4000]
GoRed               ROUTINE
  ?StatusImage{PROP:Text} = '~KPServError.ico'
  ?PrintButton{PROP:Disable} = TRUE

! [Priority 4000]
UndoQuery           ROUTINE
  BRW4::View:Browse{PROP:SQLFilter} = ''
  BRW4.ResetFromBuffer
  BRW4.PostNewSelection

! [Priority 4000]
LoadQueryAction     ROUTINE
  DATA
TempQuery   STRING(5000)
  CODE
    TempQuery = LoadQuery(0{PROP:Text})
    IF ~CLIP(TempQuery) THEN EXIT.
    LOC:QueryBuilder = TempQuery

    DISPLAY(?LOC:QueryBuilder)

    IF CheckQuery(LOC:QueryBuilder)
      DO GoGreen
      DO ExecQuery
    ELSE
      DO GoRed
    END
SaveQueryAction     ROUTINE
  IF ~CLIP(LOC:QueryBuilder) THEN EXIT.
  SaveQuery(0{PROP:Text},LOC:QueryBuilder)
DropData            ROUTINE
  DATA
RowChoice   LONG
ColumnChoice    LONG
FieldChoice STRING(250)
PrefixLen   LONG
QCopy   QUEUE,BINDABLE
HSITE     LONG
HPalletNum    LONG
HHoldTicket   LONG
HPONumber LONG
HDate     LONG
HTime     LONG
HStatus   LONG
LType     LONG
LVendorID LONG  !Bob
HOraclePallet LONG
LStatus   LONG
LSite     LONG
LPalletNum    LONG
        END
ValPic  STRING(20)
  CODE
    RowChoice = ?HoldList{PROPLIST:MouseDownRow}
    ColumnChoice = ?HoldList{PROPLIST:MouseDownField}
    GET(Queue:Browse,RowChoice) ; IF ERRORCODE() THEN EXIT.
    LOC:Alpha = WHAT(Queue:Browse,ColumnChoice)
    ValPic = ?HoldList{PROPLIST:Picture,ColumnChoice}
    CASE UPPER(ValPic[2])
    OF 'S'
      LOC:Alpha = '''' & CLIP(LOC:Alpha) & ''''
    OF 'D'
      LOC:Alpha = 'DATE<' & FORMAT(LOC:Alpha,@D01) & '>'
    OF 'T'
      LOC:Alpha = 'TIME<' & FORMAT(LOC:Alpha,@T04) & '>'
    END
    FieldChoice = WHO(QCopy,ColumnChoice)
! stop(FieldChoice)
    PrefixLen = LEN('f')
    LOC:QueryField = UPPER(FieldChoice[PrefixLen + 1 : LEN(CLIP(FieldChoice))]) & ']'

    IF UPPER(FieldChoice[1]) = 'H' 
      LOC:QueryField = 'QD_HOLD.[' & CLIP(LOC:QueryField) 
    ELSE 
      LOC:QueryField = 'ID_LOT.[' & CLIP(LOC:QueryField)
    END
    LOC:QueryAction = '='
    DISPLAY(?LOC:QueryField)
    DISPLAY(?LOC:Alpha)
    DISPLAY(?LOC:QueryAction)

! [Priority 4000]
AcceptQuery         ROUTINE
  IF CheckQuery(LOC:QueryBuilder)
    DO GoGreen
  ELSE
    DO GoRed
  END
!-------- init embed code.
  SELF.Open(Window)                                        ! Open window
  ! [Priority 8001]
    DO QuerySetup

!----- Takeaccepted
  CASE FIELD()
  OF ?TextAdd
    DO BuildText
      
  OF ?EnterAllButton
    DO EnterAll
      
  OF ?SendBetween
    BuildAction('BETWEEN')
  OF ?SendSum
    BuildAction('SUM')
  ! etc.
  OF ?ClearAll
    DO ClearAll ; DO UndoQuery
  
  OF ?ExecQuery
    DO ExecQuery
  OF ?LoadQuery
    DO LoadQueryAction
  OF ?SaveQuery:2
    DO SaveQueryAction
  OF ?LOC:QueryBuilder
    DO AcceptQuery
  
  !-- Event code - TakeNewSelection
  OF ?LOC:QueryField
    DO BuildField
  
  OF ?LOC:QueryAction
      ! BuildAction(LOC:QueryAction)
  END
  
CheckQuery          PROCEDURE(pQuery)
LocalReturnValue      BYTE
  CODE
    OPEN(QCheckView)
    QCheckView{PROP:SQL} = 'SET NOEXEC ON SELECT * FROM ' & NAME(QD_Hold) & |
      ' JOIN ' & NAME(ID_Lot) & ' ON QD_Hold.[PalletNum] = ID_Lot.[PalletNum] ' & |
      ' WHERE ' & CLIP(DecodeQuery(pQuery)) & ' SET NOEXEC OFF'
    IF ERRORCODE() = 0 THEN LocalReturnValue = TRUE.
    CLOSE(QCheckView)
    DO EndLocalProcedure
EndLocalProcedure   ROUTINE
  RETURN(LocalReturnValue)

! [Priority 4000]
DecodeQuery         PROCEDURE(pCodedQuery)
LocalReturnValue      STRING(10000)
StringPos             LONG
EndBracket            LONG
CodeLen               LONG

  CODE
    CodeLen = LEN('DATE<')
 ! Fix Dates
    LOOP
      StringPos = INSTRING('DATE<',pCodedQuery,1,1)
      EndBracket = INSTRING('>',pCodedQuery,1,StringPos)
      IF StringPos AND EndBracket
        pCodedQuery = pCodedQuery[1 : StringPos - 1] & |
          DEFORMAT(pCodedQuery[StringPos + CodeLen : EndBracket - 1],@D01) & |
          pCodedQuery[EndBracket + 1 : LEN(CLIP(pCodedQuery))]
      ELSE
        BREAK
      END
    END

 ! Fix Times
    LOOP
      StringPos = INSTRING('TIME<',pCodedQuery,1,1)
      EndBracket = INSTRING('>',pCodedQuery,1,StringPos)
      IF StringPos AND EndBracket
        pCodedQuery = pCodedQuery[1 : StringPos - 1] & |
          DEFORMAT(pCodedQuery[StringPos + CodeLen : EndBracket - 1],@D04) & |
          pCodedQuery[EndBracket + 1 : LEN(CLIP(pCodedQuery))]
      ELSE
        BREAK
      END
    END

    LocalReturnValue = pCodedQuery
    RETURN(pCodedQuery)

! [Priority 4000]
BuildAction         PROCEDURE(pAct)
  CODE
    IF CLIP(LOC:QueryBuilder)
      LOC:QueryBuilder = CLIP(LOC:QueryBuilder) & ' ' & pAct
    ELSE
      LOC:QueryBuilder = pAct
    END

    DISPLAY(?LOC:QueryBuilder)

    IF CheckQuery(LOC:QueryBuilder) THEN DO GoGreen ELSE DO GoRed.
    RETURN
